/*********************************************************************************************************************
**	automesh.h
**
**
*********************************************************************************************************************/

#ifndef _INC_AUTOMESH
#define _INC_AUTOMESH

#ifndef _INC_WINDOWS
#include <windows.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define CLIP( v )						( (BYTE)min( 255, max( 0, (v) ) ) )
#define DIB_WIDTHBYTES( bits )			( ((bits) + 31) / 32 * 4 )

typedef HGLOBAL			HDIB;

typedef unsigned char	*LPDIB;
typedef struct tagRAW
{
	int				cx, cy;
	unsigned char	lpPixel[1];
} RAW, *LPRAW;

typedef struct tagGRAPH *LPGRAPH;
typedef struct tagGRAPH
{
	int			x, y;
	int			iConnect;
	LPGRAPH		lpConnect[8];
} GRAPH;

typedef struct tagMESH
{
	int			mx, my;
	POINT		pt[1];
} MESH, FAR *LPMESH;

// dllmain.c
extern HINSTANCE	hDLLInstance;

// dib.c
int  GetBppOfDib( HDIB hdib );
BOOL IsGrayPalette( HDIB hdib );
HDIB DupDib( HDIB hdib );
HDIB NewGrayPaletteDib( int cx, int cy );
HDIB TrueColor2GrayPaletteDib( HDIB hsrc );

// raw.c
LPRAW	BlankRaw( int cx, int cy );
LPRAW	DupRaw( LPRAW lpRaw );
LPRAW	Dib2Raw( HDIB hdib );

// gradient.c
HDIB GetThresholdedImageWithSobelGradient( HDIB hdib, int iT );

// thinning.c
BOOL GetThinnedBitmap( LPRAW lpRaw );

// graph.c
LPGRAPH *GenerateGraphAll( LPRAW lpRaw );
void FreeGraphAll( LPGRAPH *lpGrpBlock );

// mesh.c
LPMESH	CreateMesh( HDIB hdib, int mx, int my, int iT );
void DestroyMesh( LPMESH lpMesh );

#ifdef __cplusplus
}
#endif

#endif