// DstView.cpp : implementation file
//

#include "stdafx.h"
#include "Warp.h"

#include "MainFrm.h"
#include "DstView.h"
#include "global.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDstView

IMPLEMENT_DYNCREATE(CDstView, CView)

CDstView::CDstView()
{
	m_bDrag = FALSE;
	m_nDragMeshX = -1;
	m_nDragMeshY = -1;
	m_bShowMesh = FALSE;
}

CDstView::~CDstView()
{
}


BEGIN_MESSAGE_MAP(CDstView, CView)
	//{{AFX_MSG_MAP(CDstView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDstView drawing

void CDstView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here

	m_pixmap.Draw( pDC->GetSafeHdc(), 0, 0 );

	if( m_bShowMesh )
		m_mesh.Draw( pDC->GetSafeHdc(), 0, 0 );
}

/////////////////////////////////////////////////////////////////////////////
// CDstView diagnostics

#ifdef _DEBUG
void CDstView::AssertValid() const
{
	CView::AssertValid();
}

void CDstView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

void CDstView::CreateMesh( int cx, int cy )
{
	m_mesh.Create( m_pixmap.GetWidth(), m_pixmap.GetHeight(), cx, cy );
	m_bShowMesh = TRUE;
}

void CDstView::Load( LPCTSTR file, int cxMesh, int cyMesh )
{
	m_pixmap.CreateFromBMP( file );
	CreateMesh( cxMesh, cyMesh );
}

/////////////////////////////////////////////////////////////////////////////
// CDstView message handlers

void CDstView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();

	CMainFrame *pwnd = (CMainFrame *)AfxGetMainWnd();
	Load( "FACE360.BMP", pwnd->m_cxMesh, pwnd->m_cyMesh );
	Invalidate();
	
	// TODO: Add your specialized code here and/or call the base class
//	m_mesh.Create( 320, 240, 8, 8 );
//	m_pixmap.CreateFromBMP( (LPCTSTR)FNAME_DEFAULT_BMP );
}

void CDstView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	POINT meshPoint;

	if( m_bShowMesh )
	{
		if(m_mesh.HitTest(point.x, point.y, &meshPoint))
		{
			m_bDrag = TRUE;
			m_nDragMeshX = meshPoint.x;
			m_nDragMeshY = meshPoint.y;
			Invalidate( FALSE );

			SetCapture();
		}
	}
	
	CView::OnLButtonDown(nFlags, point);
}

void CDstView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if( m_bShowMesh )
	{
		m_bDrag = FALSE;

		ReleaseCapture();
	}
	
	CView::OnLButtonUp(nFlags, point);
}

void CDstView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if( m_bShowMesh )
	{
		if(m_bDrag)
		{
			m_mesh.SetMeshPoint(m_nDragMeshX, m_nDragMeshY, point.x, point.y);
			Invalidate(FALSE);
		}
	}

	CView::OnMouseMove(nFlags, point);
}
