//////////////////////////////////////////////////////////////////
// MeshWarp.cpp - Mesh warping program
//
// ޽
//
//  : George Wolberg, "Digital Image Warping" 
//
// 1998. 6    plusjune ۼ
// 1999. 1.11 newtype   - Indentation
// 1999. 1.12 newtype   - TPixmax

//#include "Maf.h"
#include "TPixmap.h"
#include "TMesh.h"

BOOL InterpolSpline(double *x1, double *y1, int len1, double *x2, double *y2, int len2);
void Resample(double F[], BYTE *IN, BYTE *OUT, int INlen, int OUTlen);


BOOL MeshWarp(TPixmap *pSrcPixmap, TMesh *pSrcMesh, TPixmap *pDstPixmap, TMesh *pDstMesh)
{
	int nWidth = pSrcPixmap->GetWidth();
	int nHeight = pSrcPixmap->GetHeight();

	int nMeshWidth = pSrcMesh->GetWidth();
	int nMeshHeight = pSrcMesh->GetHeight();

	// ĵ   ޸ Ҵ
	//
	int m = max(nWidth, nHeight) + 1;
	double *pIndex = new double[m];
	
	double *pRowX1 = new double[m];
	double *pRowY1 = new double[m];

	double *pRowX2 = new double[m];
	double *pRowY2 = new double[m];

	double *pMap1  = new double[m];
	double *pMap2  = new double[m];

	// ---------------------------------------------------------------------
	// ù ° н غ ۾
	//

	// ҽ  öο  x-intercept ̺ 
	//
	double *pSrcMeshTab = new double[nMeshWidth * nHeight];
	double *pDstMeshTab = new double[nMeshWidth * nHeight];

	int x, y;
	int nValX, nValY;

	for( y = 0; y < nHeight; y++)
		pIndex[y] = y;

	for( x = 0; x < nMeshWidth; x++)  //  ö  
	{
		//  ö ĵ 
		//
		for(y = 0; y < nMeshHeight; y++)
		{
			pSrcMesh->GetMeshPoint(x, y, nValX, nValY);
			pRowX1[y] = (double)nValX;
			pRowY1[y] = (double)nValY;

			pDstMesh->GetMeshPoint(x, y, nValX, nValY);
			pRowX2[y] = (double)nValX;
			pRowY2[y] = (double)nValY;
		}

		InterpolSpline(pRowY1, pRowX1, nMeshHeight, pIndex, pMap1, nHeight);
		InterpolSpline(pRowY2, pRowX2, nMeshHeight, pIndex, pMap2, nHeight);

		for(y = 0; y < nHeight; y++ )
		{
			pSrcMeshTab[nMeshWidth * y + x] = pMap1[y];
			pDstMeshTab[nMeshWidth * y + x] = pMap2[y];
		}
	}

	// ---------------------------------------------------------------------
	// ù° н : 
	TPixmap *pTmpPixmap = new TPixmap;
	pTmpPixmap->Create(nWidth, nHeight );

	for( x = 0; x < nWidth; x++)
		pIndex[x] = x;

	LPBYTE pScanLineSrc = (LPBYTE)GlobalAlloc(GPTR, pSrcPixmap->GetWidthBytes());
	LPBYTE pScanLineDst = (LPBYTE)GlobalAlloc(GPTR, pSrcPixmap->GetWidthBytes());

	for(y = 0; y < nHeight; y++ )
	{
		double *pX1 = &pSrcMeshTab[nMeshWidth * y];
		double *pX2 = &pDstMeshTab[nMeshWidth * y];

		InterpolSpline(pX1, pX2, nMeshWidth, pIndex, pMap1, nWidth);

		pSrcPixmap->GetHorzScanLine(pScanLineSrc, y);
		Resample(pMap1, pScanLineSrc, pScanLineDst, nWidth, nWidth);
		pTmpPixmap->SetHorzScanLine(pScanLineDst, y);
	}

	delete[] pSrcMeshTab;
	delete[] pDstMeshTab;

	// ---------------------------------------------------------------------
	// ι° н غ:
	pSrcMeshTab = new double[nMeshHeight * nWidth];
	pDstMeshTab = new double[nMeshHeight * nWidth];

	for( x = 0; x < nWidth; x++)
		pIndex[x] = x;

	for(y = 0; y < nMeshHeight; y++)  //  ö  
	{
		//  ö ĵ 
		//
		for(x = 0; x < nMeshWidth; x++)
		{
			pSrcMesh->GetMeshPoint(x, y, nValX, nValY);
			pRowX1[x] = (double)nValX;
			pRowY1[x] = (double)nValY;

			pDstMesh->GetMeshPoint(x, y, nValX, nValY);
			pRowX2[x] = (double)nValX;
			pRowY2[x] = (double)nValY;
		}

		InterpolSpline(pRowX1, pRowY1, nMeshWidth, pIndex, &pSrcMeshTab[nWidth * y], nWidth);
		InterpolSpline(pRowX2, pRowY2, nMeshWidth, pIndex, &pDstMeshTab[nWidth * y], nWidth);
	}

	// ---------------------------------------------------------------------
	// ι° н : 
	GlobalFree((HANDLE)pScanLineSrc);
	GlobalFree((HANDLE)pScanLineDst);

	pScanLineSrc = (LPBYTE)GlobalAlloc(GPTR, pSrcPixmap->GetHeightBytes());
	pScanLineDst = (LPBYTE)GlobalAlloc(GPTR, pSrcPixmap->GetHeightBytes());

	for( y = 0; y < nHeight; y++)
		pIndex[y] = y;

	for(x = 0; x < nWidth; x++ )
	{

		for( y = 0; y < nMeshHeight; y++)
		{
			pRowX1[y] = pSrcMeshTab[nWidth * y + x];
			pRowY1[y] = pDstMeshTab[nWidth * y + x];
		}
		InterpolSpline(pRowX1, pRowY1, nMeshHeight, pIndex, pMap1, nHeight);

		pTmpPixmap->GetVertScanLine(pScanLineSrc, x);
		Resample(pMap1, pScanLineSrc, pScanLineDst, nHeight, nHeight);
		pDstPixmap->SetVertScanLine(pScanLineDst, x);
	}

	GlobalFree((HANDLE)pScanLineSrc);
	GlobalFree((HANDLE)pScanLineDst);

	delete pTmpPixmap;

	delete[] pSrcMeshTab;
	delete[] pDstMeshTab;


	delete[] pIndex;
	delete[] pRowX1;
	delete[] pRowY1;
	delete[] pRowX2;
	delete[] pRowY2;
	delete[] pMap1;
	delete[] pMap2;

	return TRUE;
}


//
// Catmull-Rom ö ̼
//

BOOL InterpolSpline(double *x1, double *y1, int len1, double *x2, double *y2, int len2)
{
	int     i, j, dir, j1, j2;
	double  p1, p2, p3;
	double  x, dx1, dx2;
	double  dx, dy, yd1, yd2;
	double  a0y, a1y, a2y, a3y;


	if(x1[0] < x1[1])
	{	//  
		if(x2[0]<x1[0] || x2[len2-1]>x1[len1-1]) dir=0;
		else dir = 1;
	}
	else
	{	//  
		if(x2[0]>x1[0] || x2[len2-1]<x1[len1-1]) dir=0;
		else dir = -1;
	}

	if(dir == 0)
	{          // 
		MessageBox( NULL, "ǥ   ϴ\n",
					"  ٸ  Ѿ ʵ Ͻʽÿ", MB_ICONSTOP );
		return FALSE;
	}

	// p1 : ͹ ù° endpoint
	// p2 : resampling ġ
	// p3 : ͹ ι° endpoint
	// j  : is input index for current interval
	//

	// coefficient ʱȭ
	//
	if( dir == 1 )
		p3 = x2[0] - 1;
	else
		p3 = x2[0] + 1;

	for( i = 0 ; i < len2 ; i++ )
	{
		// ο ͹ ΰ
		p2 = x2[i];
		if( ( dir == 1 && p2 > p3 ) || ( dir == -1 && p2 < p3 ) )
		{
			// p2  ϴ ͹ ã´.
			if( dir )
			{
				for( j = 0 ; j < len1 && p2 > x1[j]; j++ );
				if( p2 < x1[j] ) j--;
			}
			else
			{
				for( j = 0 ; j < len1 && p2 < x1[j]; j++ );
				if( p2 > x1[j] ) j--;
			}

			p1 = x1[j];			// ù° endpt 
			p3 = x1[j+1];		// ι° endpt 

			j1 = max( j - 1, 0 );
			j2 = min( j + 2, len1 - 1 );

			if( p3 == p1 ) dx = 1.0;
			else dx  = 1.0 / ( p3 - p1 );
			if( p3 == x1[j1] ) dx1 = 1.0;
			else dx1 = 1.0 / ( p3 - x1[j1] );
			if( x1[j2] == p1 ) dx2 = 1.0;
			else dx2 = 1.0 / ( x1[j2] - p1 );

			dy  = ( y1[j+1] - y1[ j ] ) * dx;
			yd1 = ( y1[j+1] - y1[ j1] ) * dx1;
			yd2 = ( y1[j2 ] - y1[ j ] ) * dx2;
			a0y =  y1[j];
			a1y =  yd1;
			a2y =  dx *  ( 3*dy - 2*yd1 - yd2);
			a3y =  dx*dx*(-2*dy +   yd1 + yd2);
		}

		x = p2 - p1;
		y2[i] = ((a3y*x + a2y)*x + a1y)*x + a0y;
	}

	return TRUE;
}

