#ifndef _NGF_H_
#define _NGF_H_

#define NGF_RGB						1
#define NGF_INDEXED					2

typedef struct tagNGF
{
	char	achID[4];
	int		nType;
	int		nWidth;
	int		nHeight;
} NGF, *PNGF, *LPNGF;

class TPixmap
{
protected:
	LPNGF	m_lpNGF;

public:
	TPixmap();
	~TPixmap();

	BOOL	Create( int nWidth, int nHeight, int nType = NGF_RGB );
	BOOL	CreateFromDIB( LPBITMAPINFOHEADER lpbi, int nType = NGF_RGB );
	void	Clear();
	void	Destroy();

	// get information
	int		GetWidth();                             // get width of IPF
	int		GetHeight();                            // get height of IPF
	int		GetWidthBytes();                        // get bytes per line
	int		GetHeightBytes();

	void	GetHorzScanLine(LPBYTE lpScanBuff, int nScanLine);
	void	SetHorzScanLine(LPBYTE lpScanBuff, int nScanLine);

	void	SetVertScanLine(LPBYTE lpScanBuff, int nColum);
	void	GetVertScanLine(LPBYTE lpScanBuff, int nColum);
	void	Draw(HDC hdc, int x, int y);
	void	Draw(HDC hdc, LPRECT lpRectDC = NULL, LPRECT lpRectIPF = NULL);
};

//////////////////////////////////////////////////////////////////////////////////
// inlines

inline int  TPixmap::GetWidth() 
{ return (int)m_lpNGF->nWidth; }

inline int  TPixmap::GetHeight() 
{ return (int)m_lpNGF->nHeight; }

#endif // _NGF_H_